#
# spec file for package openal-soft
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%if 0%{?suse_version} > 1030
%bcond_without pulseaudio
%else
%if 0%{?fedora_version} > 9
%bcond_without pulseaudio
%else
%if 0%{?mandriva_version} >= 2009
%bcond_without pulseaudio
%else
%bcond_with pulseaudio
%endif
%endif
%endif

Name:           openal-soft
Version:        1.13
Release:        4.10
License:        LGPLv2.0+
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  cmake >= 2.4.4
Group:          System/Libraries
Icon:		openal.xpm
Source0:        http://kcat.strangesoft.net/openal-releases/openal-soft-%{version}.tar.bz2
Source1:        libopenalcompat.c
Source2:        openal-soft-rpmlintrc
Source3:        baselibs.conf
Summary:        OpenAL Soft
Url:            http://kcat.strangesoft.net/openal.html
Conflicts:      openal <= 0.0.8
Provides:       openal = 0.0.9
%if 0%{?mandriva_version} >= 2006
BuildRequires:  -alsa-plugins libalsa-devel
%else
BuildRequires:  alsa-devel
%endif
%if %{with pulseaudio}
BuildRequires:  pulseaudio-devel
%endif

%description
OpenAL is an audio library designed in the spirit of OpenGL--machine
independent, cross platform, and data format neutral with a clean,
simple C-based API.

OpenAL Soft is an alternative software implementation with a shared and
a cleaned up codebase, based on the windows reference implementation.



Authors:
--------
    Chris Robinson

%package devel
License:        LGPLv2.0+
Summary:        OpenAL Soft
Group:          Development/Languages/C and C++
Requires:       %{name} = %{version} glibc-devel
Provides:       openal-devel = 0.0.9
Conflicts:      openal-devel <= 0.0.8

%description devel
OpenAL is an audio library designed in the spirit of OpenGL--machine
independent, cross platform, and data format neutral with a clean,
simple C-based API.

OpenAL Soft is an alternative software implementation with a shared and
a cleaned up codebase, based on the windows reference implementation.



Authors:
--------
    Chris Robinson

%package -n libopenal0-soft
License:        LGPLv2.0+
Summary:        OpenAL Soft
Group:          System/Libraries
Provides:       libopenal0 = %version-%release
%if 0%{?suse_version} > 1010
Recommends:     openal-soft
%endif

%description -n libopenal0-soft
OpenAL is an audio library designed in the spirit of OpenGL--machine
independent, cross platform, and data format neutral with a clean,
simple C-based API.

OpenAL Soft is an alternative software implementation with a shared and
a cleaned up codebase, based on the windows reference implementation.



Authors:
--------
    Chris Robinson

%package -n libopenal1-soft
License:        LGPLv2.0+
Summary:        OpenAL Soft
Group:          System/Libraries
Provides:       libopenal1 = %version-%release
%if 0%{?suse_version} > 1010
Recommends:     openal-soft
%endif

%description -n libopenal1-soft
OpenAL is an audio library designed in the spirit of OpenGL--machine
independent, cross platform, and data format neutral with a clean,
simple C-based API.

OpenAL Soft is an alternative software implementation with a shared and
a cleaned up codebase, based on the windows reference implementation.



Authors:
--------
    Chris Robinson

%prep
%setup -q
#patch0 -p1

%build
cd build || cd CMakeConf
OPTIONS=
%if %{with pulseaudio}
if ! pkg-config --atleast-version=0.9.15 libpulse; then
	echo "Warning: pulseaudio too old, disabled"
	OPTIONS="-DPULSEAUDIO=OFF"
fi
%endif
cmake \
%if %{_lib} == lib64
    -D LIB_SUFFIX=64 \
%endif
    -D CMAKE_INSTALL_PREFIX=%{_prefix} \
    -D CMAKE_C_FLAGS:STRING="$RPM_OPT_FLAGS" \
    -D ALSOFT_CONFIG=ON \
    $OPTIONS \
    ..
make VERBOSE=1 %{?jobs:-j %jobs}
# dummy library for compatibility
#doesnt work
#gcc -Wall $RPM_OPT_FLAGS -Wl,-soname,libopenal.so.0 -shared -Wl,-f,libopenal.so.1 -o libopenal.so.0 %SOURCE1
gcc -Wall $RPM_OPT_FLAGS -fPIC -DPIC -Wl,-soname,libopenal.so.0 -shared -Wl,--no-as-needed -L. -lopenal -o libopenal.so.0 %SOURCE1

%install
cd build || cd CMakeConf
make DESTDIR=$RPM_BUILD_ROOT install
install -d %buildroot/etc/openal
install -m644 libopenal.so.0 %buildroot%{_libdir}

%post -n libopenal0-soft -p /sbin/ldconfig

%postun -n libopenal0-soft -p /sbin/ldconfig

%post -n libopenal1-soft -p /sbin/ldconfig

%postun -n libopenal1-soft -p /sbin/ldconfig

%clean
rm -rf "$RPM_BUILD_ROOT"

%files
%defattr(-,root,root)
%doc COPYING
%dir /etc/openal
%config(noreplace) %attr(0644,root,root) /etc/openal/alsoft.conf
%{_bindir}/openal-info

%files -n libopenal1-soft
%defattr(-,root,root)
%{_libdir}/libopenal.so.1
%{_libdir}/libopenal.so.1.*

%files -n libopenal0-soft
%defattr(-,root,root)
%{_libdir}/libopenal.so.0

%files devel
%defattr(-,root,root)
%{_libdir}/libopenal.so
%{_libdir}/pkgconfig/openal.pc
%dir %{_includedir}/AL
%{_includedir}/AL/al.h
%{_includedir}/AL/alc.h
%{_includedir}/AL/alext.h
%{_includedir}/AL/efx.h
%{_includedir}/AL/efx-creative.h

%changelog
* Mon Feb 21 2011 lnussel@suse.de
- new version 1.13
  * Added support for the ring modulator EFX effect.
  * Duplication of stereo sources (onto side- and rear-channels) in now enabled by default.
    This can still be disabled via alsoft.conf.
  * Support for the new AL_SOFT_loop_points and AL_SOFT_buffer_sub_data extensions.
  * Added the ability to redirect log output to a file, by setting the ALSOFT_LOGFILE environment variable.
  * Improved invalid parameter checks.
  * Better checks against integer overflows when allocating buffer storage.
  * Internal mixer support for 8-, 16-, and 32-bit input formats, improving memory consumption by not converting them all to 32-bit.
  * Improved device-change handling with the PulseAudio backend.
  * All available PulseAudio devices are now enumerated with ALC_ENUMERATE_ALL_EXT.
  * PulseAudio devices again use the periods and period_size config options.
  * Improved stability when PortAudio is enabled.
    The library tends to cause a crash when it's unloaded and reloaded.
  * Added a WaveOut backend for Windows.
  * Added a cubic resampler to replace the cosine resampler.
  * Increased the maximum number of source auxiliary sends to 4, and changed the default to 1.
  * Massive internal changes to the mixer and buffer loading code, designed for future improvements for allowable input and output formats.
* Tue Mar 30 2010 lnussel@suse.de
- new version 1.12.854
  * Fixed playback when the PulseAudio buffer is calculated to be more than 64KB.
  * Restored compatibility with some older PulseAudio libs.
  * Alternative buffer sizing for PulseAudio, specified using a new config option.
  * Improved buffer size calculations, to prevent drastic latency changes when certain properties (such as ALC_FREQUENCY) are modified.
  * Added capture support for the PortAudio backend.
  * Support for PortAudio under Windows.
  * Added support for the format extensions AL_EXT_MULAW, AL_EXT_MULAW_MCFORMATS, and AL_EXT_DOUBLE.
  * Support for the new ALC_EXT_thread_local_context extension.
  * Improved library load time by delaying backend device probing until needed.
  * Updated alext.h to provide EFX tokens and function types.
  * Unsupported effects and filters are no longer returned by alGetEnumValue.
  * The Wave File Writer device now creates WAVEFORMATEXTENSIBLE files, to better handle multi-channel and float output.
* Mon Jan 18 2010 lnussel@suse.de
- new version 1.11.753
  * Fixed compatibility with newer PulseAudio libs
  * The PulseAudio backend will now be tried first, when available
  * Fixed a crash with the echo effect
  * Configurable resampler, supporting point, linear (default), and
    cosine methods
  * Improved reverb, which now supports the Modulation and Echo
    properties
  * The alsoft/.conf/.ini/rc drivers config option now allows unnamed
    backends to remain available, by ending the device list with a
    comma (,)
  * PulseAudio playback will try to use an output frequency and
    channel format that best matches the default sink If the sink
    device is configured for 5.1 output at 48khz, for example, OpenAL
    Soft will automatically use 5.1 output at 48khz, unless overridden
    in the config file.
  * Multi-channel sounds are now passed through the auxiliary sends
    Although they are down-mixed to mono, losing channel separation.
  * Fixed playback when creating a second context from a device
  * Added a new config option to enable real-time priority when mixing
    for certain backends (ALSA, OSS, Solaris, and DirectSound)
  * Buffers now store 32-bit float sample data internally, to retain
    32-bit sample accuracy
  * Added a new head-dampening config option, for mono and stereo
    playback This slightly filters sounds coming from behind, allowing
    for some subtle differences between front and back sound sources.
  * Added an option to allow spawning the PulseAudio server on demand
  * Support for the new AL_EXT_source_distance_model extension
* Mon Jan  4 2010 lnussel@suse.de
- update to current git snapshot
* Fri Dec 18 2009 jengelh@medozas.de
- add baselibs.conf as a source
* Mon Nov  9 2009 lnussel@suse.de
- new version 1.10.622
  * Fixed OSS and PulseAudio backends
  * Support for disconnect notifications with PulseAudio when the
    server connection dies
  * Fixed surround sound channel ordering for PulseAudio playback
  * Fixed 7.1 output
  * Fixed potential crash when setting an AL_EFFECT_NULL effect on
    an auxiliary effect slot
  * Backend libraries are now loaded and released as needed
    In particular, this allows for backends to be added and
    removed at runtime when their corresponding libraries are
    installed and uninstalled (provided support for those backends
    was compiled in). An active backend will remain available as
    long as its in use.
  * Support for multiple contexts per device
  * Fixed possible ghost references on buffers and auxiliary
    slots, if they're attached to sources that are forcibly
    deleted on context destruction
- only actually pulseaudio if at least version 0.9.15
* Sun Nov  1 2009 lnussel@suse.de
- update to current git snapshot to fix problems with pulseaudio
  (bnc#551022)
- disable --as-needed for libopenal.so.0 compatibility library to
  force linking against libopenal.so.1
* Thu Oct 29 2009 lnussel@suse.de
- new version 1.9.563
  * Preliminary support for the new ALC_EXT_disconnect extension.
  * Support for 32-bit float playback and capture on some backends
  * Proper support for the ALC_FREQUENCY context attribute
  * Fixed compatibility with newer PulseAudio libs.
  * Fixed parsing of the speaker layout config string.
  * Fixed buffer size issues with ALSA capture.
  * Fixed a problem where the reported number of processed buffers could be wrong.
  * Fixed possible crashes when specifying invalid device pointers.
  * Removed the backend-specific period config options, and made it a global option instead.
  * Deprecated the refresh config option for the new period_size option.
  * Better cleanup of backends when the OpenAL lib is unloaded.
* Tue Jun  9 2009 lnussel@suse.de
- new version 1.8.466
  * Support for two more effects: AL_EFFECT_EAXREVERB and AL_EFFECT_ECHO
    Not all of the EAXREVERB properties will currently affect the output. More
    should be supported in the future
  * Improved reverb
  * Added a PulseAudio backend
  * Improved mixer efficiency a bit
  * Improved ALSA playback
  * Multiple auxiliary slots supported
    Default is four, which can be modified with the config file
  * Multiple auxiliary sends supported
    Default is two per source, which cannot be increased without recompilation.
    The amount can be decreased with the config file
* Wed May  6 2009 lnussel@suse.de
- new version 1.7.411
  * New table-based panning algorithm, allowing the center channel to be included in the mix
  * Speaker arrangements are now configurable
  * Added a new PortAudio backend
  * Some changes to the ALSA device list
    Standard enumeration will now only list a single ALSA playback device (for "default"), and there should be no more name clashes preventing a device with the same name from being used
  * Low-pass filters now affect multi-channel sources
  * Corrections for 6.1 channel placements
  * Multi-channel sources are now re-mixed when using a different output mode
    This prevents source channels from being lost if there isn't a matching output channel (eg. 5.1 sources on stereo output)
  * Multi-channel source gains are now correctly clamped to the source's min/max gains
  * The air absorption calculation now uses the correct distance
  * The source room rolloff factor can now be set up to 10
  * Updated reverb code that better follows the reverb parameters
- add pulseaudio backend from git head and enable by default
* Fri Apr 17 2009 lnussel@suse.de
- add shlib policy conform provides for libraries
* Fri Jan  9 2009 lnussel@suse.de
- new version 1.6.372
  * Channel volumes are now ramped from source position changes and when starting playback, to help prevent pops and clicks
  * The AL_DOPPLER_FACTOR source property works
  * Implemented a new Solaris backend for playback
  * The openal-info example will now print EFX information
  * More EFX compliance fixes
  * Support for non-mmap ALSA capture
  * A new low-pass filter, based on the I3DL2 specification
  * The ALSOFT_CONF environment variable may be used to specify an additional configuration file
  * A completely new reverb effect implementation
  * Improved CPU use for the DirectSound backend
* Wed Aug 20 2008 lnussel@suse.de
- new version 1.5.304
  * reduces buffer size to reduce latency
  * installs pkg-config file
  * better EFX compliance
  * fixes doppler shift
  * needs less memory in the mixer
* Thu Jul 17 2008 lnussel@suse.de
- backport patch to reduce buffer size from git
- fix mandriva build
* Thu Jun  5 2008 lnussel@suse.de
- split package to have libraries in subpackages
* Thu Jun  5 2008 lnussel@suse.de
- new package version 1.4.272 based on b-s-a's and ickruis' work
